/* Timing tests for libaa (the affine arithmetic library) */
/* Last edited on 2007-01-04 00:14:08 by stolfi */

#include <aa.h>
#include <flt.h>
#include <ioprotos.h>
#include <stdio.h>
#include <timefunc.h>
/* #include <sys/ieeefp.h> */

int ieee_flags(char *a, char *b, char *c, char **out);

int main (void);

int do_empty(int ntimes);
int do_aa_add(int ntimes);
int do_aa_mul(int ntimes);

#define NTIMES 10000
#define NEPS 10

int main (void)
  {
    aa_init();
    
    time_func("empty loop",     do_empty,       NTIMES);
    time_func("aa_add",         do_aa_add,      NTIMES);
    time_func("aa_mul",         do_aa_mul,      NTIMES);
    return(0);
  }
    
int do_empty(int ntimes)
  { int i;
    MemP frame = aa_top();
    AAP x = aa_throw(NEPS);
    AAP y = aa_throw(NEPS);
    MemP locframe = aa_top();
    AAP z;
    for (i=0; i<ntimes; i++) 
      { /* do nothing */
        z = x; x = y; y = z; /* To pacify the compiler. */
        aa_flush(locframe);
      }
    aa_flush(frame);
    return (ntimes);
  }
 
int do_aa_add(int ntimes)
  { int i;
    MemP frame = aa_top();
    AAP x = aa_throw(NEPS);
    AAP y = aa_throw(NEPS);
    MemP locframe = aa_top();
    AAP z;
    for (i=0; i<ntimes; i++)
      { z = aa_add(x, y);
        z = aa_add(x, y);
        z = aa_add(x, y);
        z = aa_add(x, y);
        z = aa_add(x, y);
        z = aa_add(x, y);
        z = aa_add(x, y);
        z = aa_add(x, y);
        z = aa_add(x, y);
        z = aa_add(x, y);
        aa_flush(locframe);
      }
    aa_flush(frame);
    return (10*ntimes);
  }
    
int do_aa_mul(int ntimes)
  { int i;
    MemP frame = aa_top();
    AAP x = aa_throw(NEPS);
    AAP y = aa_throw(NEPS);
    MemP locframe = aa_top();
    AAP z;
    for (i=0; i<ntimes; i++)
      { z = aa_mul(x, y);
        z = aa_mul(x, y);
        z = aa_mul(x, y);
        z = aa_mul(x, y);
        z = aa_mul(x, y);
        z = aa_mul(x, y);
        z = aa_mul(x, y);
        z = aa_mul(x, y);
        z = aa_mul(x, y);
        z = aa_mul(x, y);
        aa_flush(locframe);
      }
    aa_flush(frame);
    return (10*ntimes);
  }
    

