/* See irange.h */
/* Last edited on 2007-04-16 23:00:24 by stolfi */

#include <irange.h>
#include <stdint.h>
#include <stdlib.h>

irange_t irange_join(irange_t *u, irange_t *v)
  { int32_t ulo = LO(*u), uhi = HI(*u);
    int32_t vlo = LO(*v), vhi = HI(*v);
    irange_t w;
    LO(w) = (ulo < vlo ? ulo : vlo);
    HI(w) = (uhi > vhi ? uhi : vhi);
    return w;
  }

irange_t irange_meet(irange_t *u, irange_t *v)
  { int32_t ulo = LO(*u), uhi = HI(*u);
    int32_t vlo = LO(*v), vhi = HI(*v);
    irange_t w;
    LO(w) = (ulo > vlo ? ulo : vlo);
    HI(w) = (uhi < vhi ? uhi : vhi);
    return w;
  }

void irange_widen(irange_t *r, int32_t margin)
  { LO(*r) = LO(*r) - margin;
    HI(*r) = HI(*r) + margin;
  }
