/* Find item in a sorted table by linear interpolation + binary search. */
/* Last edited on 2006-03-14 13:03:27 by stolfi */ 

#ifndef tbfind_H
#define tbfind_H

int tb_find(double f(int i), int iMin, int iMax);
  /* Assumes that {f()} is a function defined over {iMin..iMax}.
    Returns an index {k} in {iMin..iMax} such that {f(k-1) < 0 <=
    f(k)} As special cases, if {0 <= f(iMin)}, returns {iMin}; if
    {f(iMax) < 0}, returns {iMax+1}; if {iMin > iMax}, returns {iMin}.
    Uses a combination of bisection and linear interpolation.
    
    The procedure works with any function {f()}, but is most useful if
    if {f()} is non-decreasing. In that case, if there is some {k} in
    {iMin..iMax} such as {f(k) == 0}, the procedure will return that
    {k}. */

#endif
